<?php
	
require_once( $_SERVER['DOCUMENT_ROOT'] . '/clutch-config.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/includes/helper-functions.php' );

require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/clutch-class.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/db-handler-class.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/scraper-classes.php' );

$db_handler = new db_handler;

$counter = @$_GET['counter'] ? $_GET['counter'] : 0;

$sql = "
	SELECT
		l.*,d.*
	FROM
		`awc_locations` l,
		`awc_location_details` d
	WHERE
		d.`location_id` = l.`location_id`
		&& (
			d.`google_scraped` < 1
			|| d.`google_scraped_date` < '2022-07-03 00:00:00'
		)
		&& d.`brands` LIKE '%graber%'
	ORDER BY l.`lng` ASC
	LIMIT 5
";

$locations = $db_handler->run_query( $sql, 'all' );

$page_content = '';

if( is_array( $locations ) && 0 < count( $locations ) ) {
	
	$do_refresh = true;
	
	foreach( $locations as $location ) {
		
		if( is_array( $location ) ) {

			$google = new google_scraper;
			$google_data = $google->get_google_place( $location['location_name'] . ' ' . $location['city'] . ' ' . $location['state'] );

			$scraper = new clutch_scraper;

			if( @$google_data ) {

				if( 'US' == $google_data['country'] || 'CA' == $google_data['country'] ) {
					$location = $scraper->merge_google_data( $location, $google_data );
				}
				
				else {
					$location['google_data'] = $google_data;
					$location['country'] = $google_data['country'];
				}

			}
			
			$location['google_scraped'] = 1;
			$location['google_scraped_date'] = date( "Y-m-d H:i:s" );

			$scraper->store_location( $location );
			
			$page_content .= '<strong>' . $location['location_name'] . ', ' . $location['city'] . ' ' . $location['state'] . '</strong> updated' . ( @$google_data ? ' Google data with' : ' Google data without' ) . '<br>';
			
		}

		
		
	}
	
}
else {
	$do_refresh = false;
}

?>
<!doctype html>
<html>
<head>
<meta charset="UTF-8">
<title>Untitled Document</title>
</head>
<body>
	
	<?php
	
	echo date( "Y-m-d H:i:s" ) . '<hr><br>';
	echo $page_content;
	
	if( @$scraper && @$scraper->errors ) {
		echo '<pre>' . print_r( $scraper->errors, 1 ) . '</pre>';
	}
	
	?>
	
	
	<?php if( @$do_refresh && 100 >= $counter ) : ?>
	<script>
		setTimeout( function() {
			window.location.href = 'https://local.scraper.com/fetch-google-data.php?counter=<?php echo ($counter+1); ?>';
		}, 500 );
	</script>
	<?php endif; ?>
	
</body>
</html>