<?php

/**
 * Returns a formatted 10-digit phone number
 *
 * @return string $formatted
 **/
function tenToTel( $string ) {
	$formatted = telToTen( $string );

	if( '' === $formatted ) {
		return '';
	}
	return sprintf(
		'%s-%s-%s',
		substr( $formatted, 0, 3 ),
		substr( $formatted, 3, 3 ),
		substr( $formatted, 6, strlen( $formatted ) )
	);
}

/**
 * Formats a given phone number $string to remove all non-numeric characters
 * Also removes leading 0 or 1 since no 10-digit phone number starts with these numbers
 *
 * @return string $formatted
 **/
function telToTen( $string ) {
	$formatted = preg_replace( '/[^\d]/', '', $string );
	$formatted = preg_replace( "(^1)", "", $formatted );
	$formatted = preg_replace( "(^0)", "", $formatted );
	return $formatted;
}

function clutch_db_case( $string ) {
	$string = preg_replace('/[^\da-zA-Z- ]/i', '', trim( $string ) );
	$string = preg_replace( "( +)", "-", trim( $string ) );
	$string = preg_replace( "(-+)", "-", trim( $string ) );
	return strtolower( $string );
}
