cslmap.all_the_locations = [];
cslmap.all_location_ids = [];

var output_textarea = jQuery('<textarea style="width:100vw;height:100vh;"></textarea>').prependTo( 'body' );

cslmap.zips_to_fetch = [
	80829,
	80229,
	80526
];

cslmap.zips_processed = [];

cslmap.process_ajax_response = function (response) {
	valid_response = typeof response.response !== "undefined";
	if (valid_response) {
		valid_response = response.success;
	}

	/**
	 * Fires when the location search responds.
	 *
	 * @filter  location_search_responded
	 *
	 * @param   object   response
	 *
	 * @return  object
	 */
	slp_Filter("location_search_responded").publish(response);

	if (valid_response) {
		cslmap.latest_response = response;
		cslmap.clearMarkers();

		jQuery( cslmap.latest_response.response ).each( function( i, e ) {
			
			if( ! cslmap.all_location_ids.includes( parseInt( e.id ) ) ) {
				cslmap.all_the_locations.push( e );
				cslmap.all_location_ids.push( parseInt( e.id ) );
			}
			
			
		});
		
		// cslmap.all_the_locations.concat( cslmap.latest_response.response );
		
		console.log( cslmap.all_location_ids );
		
		output_textarea.text( cslmap.all_the_locations.length + ' results: ' + JSON.stringify( cslmap.all_the_locations ) );
		
		/**
		 * Manipulate the marker list returned from the backend.
		 *
		 * @filter  locations_found
		 *
		 * @param   object   response
		 *
		 * @return  object                       the modified response
		 */
		slp_Filter("locations_found").publish(response);

		cslmap.putMarkers(response.response);

		/**
		 * Fire JavaScript action 'markers_dropped' after markers are dropped.
		 */
		jQuery("#map").trigger("markers_dropped");
	} else {
		if (window.console) {
			slp.log("SLP server did not send back a valid JSONP response.");
			if (typeof response !== "undefined") {
				slp.log("Response: " + response);
			}
			if (typeof response.message !== "undefined") {
				var sidebar = document.getElementById("map_sidebar");
				sidebar.innerHTML = response.message;
			}
		}
	}

	/**
	 * Fires when the location search finished processing.
	 *
	 * @filter  location_search_responded
	 */
	slp_Filter("location_search_processed").publish();
};