<?php

require_once($_SERVER['DOCUMENT_ROOT'] . "/database.php");

function stringToNumber($string) {
	return intval(preg_replace('/[^\d]/','',$string));
 }
function ten_to_tel($tel_number) {
	$tel_number = tel_to_ten($tel_number);
	if( strlen($tel_number) > 0 && strlen($tel_number) <= 10 ) {
		$tel_number = substr($tel_number,0,3) . "-" . substr($tel_number,3,3) . "-" . substr($tel_number,6,strlen($tel_number));
	}
	return $tel_number;
 }
function tel_to_ten($tel_number) {
	$coded_tel = preg_replace('/[^\d]/','',$tel_number);
	$coded_tel = preg_replace("(^1)","",$coded_tel);
	return $coded_tel;
 }

function sendCURL($zip) {
	$sendurl = "https://api2.hunterdouglas.com/locator?locale=en-us&searchradius=50&country=US&addressline=" . $zip;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $sendurl);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$response = curl_exec($ch);
	
	curl_close($ch);
	
	echo $response . "<hr><hr><hr><hr><hr>";
	
	return $response;
 }

function concatArray($array) {
	$string = "";
	foreach($array as $k => $v) {
		$string .= $v . ",";
	}
	return rtrim($string,",");
 }

function storeDealer($dealer) {
	$connection = new clutchConnection();
	$connection->connect(false);
	
	$p = array(
		'fields' => "",
		'values' => "",
		'updates' => ""
	);
	
	foreach($dealer as $k => $v) {
		$p['fields'] .= "\r\n\t\t\t" . "`" . mysql_real_escape_string($k) . "`,";
		$p['values'] .= "\r\n\t\t\t" . "'" . mysql_real_escape_string($v) . "',";
		$p['updates'] .= "\r\n\t\t\t" . "`" . mysql_real_escape_string($k) . "`='" . mysql_real_escape_string($v) . "',";
	}
	
	$q = "
		INSERT INTO `dealers` (" . rtrim($p['fields'],",") . ")
		VALUES (" . rtrim($p['values'],",") . ")
		ON DUPLICATE KEY UPDATE " . rtrim($p['updates'],",") . "
	";
	$query = $connection->runQuery($q, "Failed to insert dealer");
	if (!@$query) {
		echo "<pre>" . print_r($connection->errors,true) . "</pre>";
		die();
	}
 }

function renderTSV($headers,$dealers,$zip) {
	echo "<hr>" . count($dealers) . " dealers in " . $zip;
	if (intval($zip) === intval($_POST['zip'])) {
		//  echo "<pre>" . print_r($headers,true) . "</pre>";
	}
	echo "<pre>" . print_r($dealers,true) . "</pre>";
	//  die();
 }

function runSequence($zip) {
	if (4 === strlen($zip)) {
		$zip = "0" . $zip;
	}
	
	if (5 === strlen($zip)) {
		$string = sendCURL($zip);
		$json = json_decode($string);
	
		$headers = array();
		$dealers = array();
		foreach($json->results as $index => $value) {
			$dealer = array();
			foreach($value as $k => $v) {
				if(
					"_distance" !== $k
					&& "_distanceuom" !== $k
					&& "hours_fr" !== $k
					&& "icon" !== $k
					&& "province" !== $k
					&& "dealercommunityactivated" !== $k
					&& "galleryimage" !== $k
					&& "date" !== $k
					&& "bho" !== $k
					//  && "clientkey" !== $k
					//  && "uid" !== $k
					//  && "criteria_1" !== $k
					//  && "criteria_2" !== $k
					//  && "criteria_3" !== $k
	
				) {
					$headers[$k] = gettype($v);
					if (is_array($v)) {
						$dealer[$k] = concatArray($v);
					} else {
						if (
							"phone" === strtolower($k)
							|| "lead_sms_phone" === strtolower($k)
						) {
							$v = tel_to_ten($v);
						}
						$dealer[$k] = $v;
					}
				}
			}
			$dealers[$dealer['hdid']] = $dealer;
			//  array_push($dealers,$dealer);
		}
		
		foreach($dealers as $hdid => $dealer) {
			foreach($headers as $k => $x) {
				if (!isset($dealer[$k])) {
					$dealer[$k] = "";
				}
			}
			storeDealer($dealer);
			$dealers[$dealer[$hdid]] = $dealer;
		}
		
		renderTSV($headers,$dealers,$zip);
	}
	
	return count($dealers);
}

if (@$_POST['zip']) {
	
	$zip = intval($_POST['zip']);
	$max = $zip+99;
	
	runSequence($zip);
	
	//  for($x=$zip;$x<=$max;$x=$x+10) {
		
	//  }
	//  die();
	
	//  echo "<pre>" . print_r($dealers,true) . "</pre>";
	
} else {
	$json = false;
}

?>

<!doctype html>
<html>
<head>
<meta charset="UTF-8">
<title>Untitled Document</title>
</head>

<body>

<form method="post" action="">
	<label for="zip">Zip<br>
		<input type="number" min="501" max="99950" name="zip" placeholder="5-Digit Zip Code" value="<?php echo $zip; ?>">
	</label>
	<input type="submit" value="Get Dealers">
	
	<hr><p>
		<?php echo $x; ?> results
		</p>
	<textarea style="width:100%;height:70vh;"><?php echo $headers . "\r\n" . $results; ?></textarea>
	
</form>

<?php



//  echo "<hr><hr><hr>JSON:<pre>" . print_r($json->results,true) . "</pre>";

?>

</body>
</html>